// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO12/16AO12_Linux_3.x.x.x.x_GSC_DN/include/16ao12_utils.h $
// $Rev: 52790 $
// $Date: 2023-04-06 16:24:11 -0500 (Thu, 06 Apr 2023) $

// 16AO12: Utilities: header file

#ifndef	__16AO12_UTILS_H__
#define	__16AO12_UTILS_H__

#include "16ao12_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ao12_close_util			(int fd, int index, int verbose);
int ao12_init_util			(int verbose);
int ao12_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ao12_open_util			(int device, int share, int index, int verbose, int* fd);
int ao12_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);
int	ao12_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	ao12_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// AO12_IOCTL_AUTO_CAL_STS
int	ao12_auto_calibrate		(int fd, int index, int verbose);								// AO12_IOCTL_AUTO_CALIBRATE
int	ao12_buffer_clear		(int fd, int index, int verbose);								// AO12_IOCTL_BUFFER_CLEAR
int	ao12_buffer_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_BUFFER_MODE
int	ao12_buffer_size		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_BUFFER_SIZE
int	ao12_buffer_status		(int fd, int index, int verbose, s32* get);						// AO12_IOCTL_BUFFER_STATUS
int	ao12_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_BURST_ENABLE
int	ao12_burst_ready		(int fd, int index, int verbose, s32* get);						// AO12_IOCTL_BURST_READY
int	ao12_burst_trigger		(int fd, int index, int verbose);								// AO12_IOCTL_BURST_TRIGGER
int	ao12_channel_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_CHANNEL_SEL
int	ao12_clock_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_CLOCK_ENABLE
int	ao12_clock_ready		(int fd, int index, int verbose, s32* get);						// AO12_IOCTL_CLOCK_READY
int	ao12_clock_ref_src		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_CLOCK_REF_SRC
int	ao12_clock_src			(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_CLOCK_SRC
int	ao12_clock_sw			(int fd, int index, int verbose);								// AO12_IOCTL_CLOCK_SW
int	ao12_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_DATA_FORMAT
int	ao12_ground_sense		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_GROUND_SENSE
int	ao12_initialize			(int fd, int index, int verbose);								// AO12_IOCTL_INITIALIZE
int	ao12_irq_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_IRQ_SEL
int	ao12_load_ready			(int fd, int index, int verbose, s32* get);						// AO12_IOCTL_LOAD_READY
int	ao12_load_request		(int fd, int index, int verbose);								// AO12_IOCTL_LOAD_REQUEST
int	ao12_nclk				(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_NCLK
int	ao12_nrate				(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_NRATE
int	ao12_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_OUTPUT_MODE
int	ao12_query				(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_QUERY
int	ao12_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AO12_IOCTL_REG_MOD
int	ao12_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AO12_IOCTL_REG_READ
int	ao12_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AO12_IOCTL_REG_WRITE
int	ao12_tx_io_abort		(int fd, int index, int verbose, s32* get);						// AO12_IOCTL_TX_IO_ABORT
int	ao12_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_TX_IO_MODE
int	ao12_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AO12_IOCTL_TX_IO_TIMEOUT
int	ao12_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// AO12_IOCTL_WAIT_CANCEL
int	ao12_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO12_IOCTL_WAIT_EVENT
int	ao12_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// AO12_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	ao12_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	ao12_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ref_src, s32* nrate, s32* nclk, double* rate);
int	ao12_fsamp_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	ao12_fsamp_report_all	(int fd, int index, int verbose, s32* fsamp);
int	ao12_id_device			(int fd, int index, int verbose);

int	ao12_count_boards		(int verbose, s32* get);
int	ao12_reg_list			(int fd, int detail);

const gsc_reg_def_t*		ao12_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*		ao12_reg_get_def_index		(int index);
const char*					ao12_reg_get_desc			(u32 reg);
const char*					ao12_reg_get_name			(u32 reg);



#endif
