// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO12/16AO12_Linux_3.x.x.x.x_GSC_DN/samples/fsamp/perform.c $
// $Rev: 52794 $
// $Date: 2023-04-06 16:27:13 -0500 (Thu, 06 Apr 2023) $

// 16AO12: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int		errs	= 0;
	FILE*	file	= NULL;
	s32		fsamp;
	s32		max		= 0;
	s32		min		= 0;
	double	rate;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
	}
	else
	{
		errs	+= ao12_query(args->fd, -1, 0, AO12_QUERY_FSAMP_MAX, &max);
		errs	+= ao12_query(args->fd, -1, 0, AO12_QUERY_FSAMP_MIN, &min);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 16AO12 Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  ==========\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		errs	+= ao12_fsamp_ao_compute(args->fd, -1, 1, fsamp, NULL, NULL, NULL, &rate);

		if (file)
			fprintf(file, "%10ld  %10.3f\n", (long) fsamp, (double) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


