// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO12/16AO12_Linux_3.x.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 52796 $
// $Date: 2023-04-06 16:27:53 -0500 (Thu, 06 Apr 2023) $

// 16AO12: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _buffer_modes(void)
{
	gsc_label("Buffer Modes");
	printf("Circular, Open\n");
}



//*****************************************************************************
static void _clocking_modes(void)
{
	gsc_label("Clocking Modes");
	printf("Sequential, Simultaneous\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Internal, External, Software\n");
}



//*****************************************************************************
static void _io_modes(void)
{
	gsc_label("I/O Modes");
	printf("PIO, Block Mode DMA\n");
}



//*****************************************************************************
static void _output_modes(void)
{
	gsc_label("Output Modes");
	printf("Differential, Single Ended\n");
}



//*****************************************************************************
static void _rate_generators(void)
{
	gsc_label("Rate Generators");
	printf("1\n");
}



//*****************************************************************************
static void _sampling_modes(void)
{
	gsc_label("Sampling Modes");
	printf("Continuous, Burst, Single Shot\n");
}



//*****************************************************************************
static void _voltage_ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10V, +-5V or +-2.5V (factory configured)\n");
}



//*****************************************************************************
static void _output_filtering(void)
{
	gsc_label("Output Lowpass Filter");
	printf("None, 10K Hz, 100K Hz  (factory configured)\n");
}



//*****************************************************************************
static void _sync_io(void)
{
	gsc_label("Sync I/O Configuration");
	printf("TTL, LVDS, and variations  (factory configured)\n");
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ao12_reg_list(args->fd, 0);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_output_modes();
	_voltage_ranges();
	_output_filtering();
	_sync_io();
	_rate_generators();
	_clocking_sources();
	_clocking_modes();
	_sampling_modes();
	_buffer_modes();
	_io_modes();

	for (i = 0; i < AO12_QUERY_LAST; i++)
		errs	+= ao12_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _register_map(args);

	return(errs);
}


